#include <stdio.h>
#include "bl_3.h"

void load_c( struct opts *options[], char bit[2], int i);
void load_gid( struct opts *options[], char gid[MAXLEN], int i);
void load_sys( struct opts *options[], char syscall[MAXLEN], int i);
void load_menu( struct opts *options[], char menu[MAXLEN], int i);
int structure( struct opts *options[], char *buf, int counter);
char *getfield( char *temp, int field );
int load_defaults( struct opts *options[], char defaults[MAXNO]);

int load_struct( struct opts *options[], char filename[MAXLEN] )
{
    int max;
    FILE *fp;
    int status;
    char buf[MAXLEN];
    int counter;
    char defaults[MAXNO];

    counter = load_defaults(options, defaults);

    if ( ( fp = fopen(filename, "r") ) == NULL ) {
	perror("can't open rc file");
	fprintf(stderr, "%s not found, exiting\n", filename);
	sleep(3);
	return ERROR;
    }

    status = 1;
    counter = 1;

    while ( status != 0 ) {
	if ( fgets(buf, HUGE, fp) == NULL ) {
	    status = 0;
	    return counter;
	}
	if ( structure(options, buf, counter) == ERROR) {
	}
	counter++;
    }
    return ERROR;
}

int load_defaults( struct opts *options[], char defaults[MAXNO])
{
    int i = 0;
    options[i] = (struct opts *) malloc( sizeof(struct opts) );
    strcpy(options[0]->c, "q");
    strcpy(options[0]->menuline, "Quit (logout)");
   
    return 1;
}

int structure( struct opts *options[], char *buf, int counter)
{
    options[counter] = (struct opts *) malloc( sizeof(struct opts) );

    load_c( options, getfield(buf, 0), counter);
    load_menu( options, getfield(buf, 1), counter);
    load_sys( options, getfield(buf, 2), counter);
    load_gid( options, getfield(buf, 3), counter);

    return OK;
}

void load_c( struct opts *options[], char bit[2], int i)
{
    bcopy( bit, options[i]->c, 2);
}

void load_menu( struct opts *options[], char menu[MAXLEN], int i)
{
    bcopy( menu, options[i]->menuline, MAXLEN);
}

void load_sys( struct opts *options[], char syscall[MAXLEN], int i)
{
    bcopy( syscall, options[i]->syscall, MAXLEN);
}

void load_gid( struct opts *options[], char gid[MAXLEN], int i)
{
    bcopy( gid, options[i]->gid, MAXLEN );
}

char *getfield( char *temp, int field )
{
    int i, j, counter;
    char buf[MAXLEN];
    char c;

    i = j = counter = 0;

    while ( counter != field ) {
	c = *(temp + j);
	j++;
	if ( c == ':')
	    counter++;
    }

    for ( i = 0; (( c = *(temp + j)) != ':'); i++, j++) {
	buf[i] = c;
    }

    buf[i] = '\0';
    return buf;
}


