#include <curses.h>
#include <stdlib.h>
#include <sys/param.h>

#include "bl_3.h"

extern void main();
extern struct opts options[];

extern int get_option( struct opts *options[], int max);

void pointer(int new_x, int old_x, int y);
void error_option( int x, int y);

int menu( /*perms*/ struct opts *options[], int max)
{
    int i, x, y, origin_x, end_x, old_x, choice_x, choice_y;
    int pointer_x_abs;
    int pointer_x_rel;
    char buffer[MAXNO];
    char host[MAXHOSTNAMELEN];
    char user[MAXNO];
    char termtype[MAXNO];
    int choice;
    int blah = 6969;

    gethostname(host, MAXHOSTNAMELEN);
    strcpy(user, getenv("USER"));
    strcpy(termtype, getenv("TERM"));

    initscr();
    cbreak();
 /* raw(); */
    noecho();

/*  Set up the top of the menu */

    x = 2; y = 9;
      sprintf(buffer, "%s %s %s", BOLD, MY_COMPANY, NORM);
      mvaddstr(x,y, buffer);
    x+= 2 ;
      sprintf(buffer, "%s Welcome to %s, %s %s term type %s",
		 INV, host, user, NORM, termtype); 
      mvaddstr(x,y,buffer);
    y = 0; x += 2;
      sprintf(buffer, "%sSelect one of the following options :%s", BOLD, NORM);
      mvaddstr(x,y,buffer);
    x+= 2;

/*  now keep record of relevant co-ords, and put the menu options up
    on display 
*/
    origin_x = x;
    old_x = x;

    for ( i = 0; i < max; i++) {
	pointer(origin_x, origin_x, 4);
	sprintf(buffer, "\t<%s>\t%s", options[i]->c, options[i]->menuline);
	mvaddstr(x,y,buffer);
	x += 1;
    }
    end_x = x - 1;
    pointer_x_abs = origin_x;
    pointer_x_rel = pointer_x_abs - origin_x;

/*  done the menu options, finish the screen */

    x += 1;
      sprintf(buffer, "%sEnter your choice :%s", BOLD, NORM);
      mvaddstr(x,y,buffer);
    move(0,0);		/* this has to be here, or the output looks shit :-/ */
    choice_x = x;
    choice_y = 20;      /* cursor for entering choices */
    refresh();

    choice = ERROR;
    while (( choice == ERROR ) || ( choice == UP_ARROW ) ||
	   ( choice == DN_ARROW ) ) {
        move(choice_x, choice_y);
        refresh();
        choice = get_option(options, max);
	if ( choice == RETURN) {
	    endwin();
	    if ( (pointer_x_abs - origin_x) == 0 ) 
		return QUIT;
	    return (pointer_x_abs - origin_x);
	}
	if ( choice == UP_ARROW ) {
	    if ( pointer_x_abs == origin_x ) {
		pointer_x_abs = end_x;
	    }
	    else {
		pointer_x_abs--;
	    }
	    if ( old_x == origin_x - 1 ) {
		old_x = end_x;
	    }
	    pointer( pointer_x_abs, old_x, 4);
	    old_x--;
	}

	if ( choice == DN_ARROW ) {
	    if ( pointer_x_abs == end_x ) 
		pointer_x_abs = origin_x;
	    else
		pointer_x_abs++;
	    if ( old_x == end_x + 1 )
		old_x = origin_x;

	    pointer( pointer_x_abs, old_x, 4);
	    old_x++;
	}
	if ( ( choice == QUIT ) || ( choice == 0 ) ) {
	    endwin();
	    return QUIT;
	}
	if ( ( choice == RETURN ) ) {
	    endwin();
	    return choice;
	}
	if ( choice == ERROR ) {
	    error_option(choice_x, choice_y);
	    endwin();
	    return ERROR;
	}
	if ( choice > -1 ) {
	    endwin();
	    if ( choice == VER ) {
		return VER;
	    }
	    return choice;
	}
	move(choice_x, choice_y);
	refresh();
    }
}


void pointer(int new_x, int old_x, int y)
/*  Function to draw a new pointer at a new x co-ord, and delete the
    old pointer, if the old_x == new_x, just draws a pointer
*/
{
    char *point = "-->";
    char *blank = "   ";

    mvaddstr(old_x, y, blank);
    mvaddstr(new_x, y, point);
    refresh();
}	

void error_option( int x, int y)
{
    mvaddstr(x+1,0,"Illegal Option, please try again");
    refresh();
    sleep(3);
}
